%global namedversion %{version}%{?namedreltag}
%global jsonprovider jackson-jaxrs-json-provider
%global smileprovider jackson-jaxrs-smile-provider
%global jaxrsbase jackson-jaxrs-base

Name:          jackson-jaxrs-providers
Version:       2.3.0
Release:       5%{?dist}
Epoch:         0
Summary:       Jackson JAX-RS providers 
License:       ASL 2.0
Group:         Development/Libraries
URL:           http://wiki.fasterxml.com/JacksonHome
Source0:       https://github.com/FasterXML/jackson-jaxrs-providers/archive/%{name}-%{version}.tar.gz
# jackson-jaxrs-providers package don't include the license file
# https://github.com/FasterXML/jackson-jaxrs-json-provider/issues/23
Source1:       http://www.apache.org/licenses/LICENSE-2.0.txt

BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: fasterxml-oss-parent >= 0:11
BuildRequires: jackson-core >= 0:2.3.0
BuildRequires: jackson-databind >= 0:2.3.0
BuildRequires: jackson-dataformat-smile >= 0:2.3.0
BuildRequires: jackson-module-jaxb-annotations >= 0:2.3.0

%if 0%{?rhel} < 7
BuildRequires: jsr311-api
Requires: jsr311-api
%else
BuildRequires: jsr-311
Requires: jsr-311
%endif

BuildRequires: build-helper-maven-plugin >= 0:1.7
BuildRequires: doclava >= 0:1.0.3
BuildRequires: jsilver >= 0:1.0.0
BuildRequires: maven-bundle-plugin >= 0:2.3.7
BuildRequires: maven-compiler-plugin
BuildRequires: maven-deploy-plugin
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-replacer-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-scm-plugin >= 0:1.7
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin

BuildArch:     noarch
BuildRoot:     %{_tmppath}/%{name}-%{namedversion}-%{release}-root

Requires: fasterxml-oss-parent >= 0:11
Requires: jackson-core = %{epoch}:%{version}
Requires: jackson-databind = %{epoch}:%{version}
Requires: jackson-annotations = %{epoch}:%{version}
Requires: jackson-module-jaxb-annotations = %{epoch}:%{version}
Requires: jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils

%description
This is a multi-module project that contains Jackson-based JAX-RS providers for
following data formats:

* JSON (https://github.com/FasterXML/jackson-core)
* Smile (https://github.com/FasterXML/jackson-dataformat-smile)
* XML (https://github.com/FasterXML/jackson-dataformat-xml)

%package -n %{name}-javadoc
Summary:       Javadoc for %{name}
Group:         Documentation
BuildRequires: jpackage-utils
Requires:      jpackage-utils

%description -n %{name}-javadoc
%{summary}.

%package -n %{jsonprovider}
Summary:       Jackson-JAXRS-JSON
Group:         Development/Libraries
BuildRequires: jpackage-utils
Requires:      jpackage-utils
Requires:      %{name} = %{epoch}:%{version}-%{release}
Requires:      %{jaxrsbase} = %{epoch}:%{version}-%{release}

%description -n %{jsonprovider}
Functionality to handle JSON input/output for JAX-RS implementations
(like Jersey and RESTeasy) using standard Jackson data binding.

%package -n %{smileprovider}
Summary:       Jackson-JAXRS-Smile
Group:         Development/Libraries
BuildRequires: jpackage-utils
Requires:      jpackage-utils
Requires:      %{name} = %{epoch}:%{version}-%{release}
Requires:      %{jaxrsbase} = %{epoch}:%{version}-%{release}

%description -n %{smileprovider}
Functionality to handle Smile (binary JSON) input/output for
JAX-RS implementations (like Jersey and RESTeasy) using standard
Jackson data binding.

%package -n %{jaxrsbase}
Summary:       Jackson-JAXRS-Base
Group:         Development/Libraries
BuildRequires: jpackage-utils
Requires:      jpackage-utils
Requires:      %{name} = %{epoch}:%{version}-%{release}

%description -n %{jaxrsbase}
Pile of code that is shared by all Jackson-based JAX-RS
providers.

%prep
# GitHub puts the project name in twice when creating a tarball.
%setup -q -n %{name}-%{name}-%{version}

%{__cp} -p %{SOURCE1} .
%{__sed} -i 's/\r//' LICENSE-2.0.txt
%pom_disable_module xml
# Tests for this package require Jersey which isn't in Brew.
%pom_xpath_remove "//pom:dependency[pom:scope='test']"

%build
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://${PWD}/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -B -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip -Dmaven.test.skip=true deploy javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

#jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{jsonprovider}/%{namedversion}/%{jsonprovider}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/%{jsonprovider}-%{namedversion}.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{jsonprovider}/%{namedversion}/%{jsonprovider}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{name}/%{jsonprovider}-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{jsonprovider}/%{namedversion}/%{jsonprovider}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/%{jsonprovider}-%{namedversion}-sources.jar

%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{smileprovider}/%{namedversion}/%{smileprovider}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/%{smileprovider}-%{namedversion}.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{smileprovider}/%{namedversion}/%{smileprovider}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{name}/%{smileprovider}-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{smileprovider}/%{namedversion}/%{smileprovider}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/%{smileprovider}-%{namedversion}-sources.jar

%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{jaxrsbase}/%{namedversion}/%{jaxrsbase}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/%{jaxrsbase}-%{namedversion}.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{jaxrsbase}/%{namedversion}/%{jaxrsbase}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{name}/%{jaxrsbase}-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{jaxrsbase}/%{namedversion}/%{jaxrsbase}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/%{jaxrsbase}-%{namedversion}-sources.jar

pushd %{buildroot}%{_javadir}/%{name}
for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done
popd

#poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{name}/%{namedversion}/%{name}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{jsonprovider}/%{namedversion}/%{jsonprovider}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{jsonprovider}.pom
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/%{smileprovider}/%{namedversion}/%{smileprovider}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{smileprovider}.pom
%{__cp} -p maven2-brew/com/fasterxml/jackson/jaxrs/jackson-jaxrs-base/%{namedversion}/%{jaxrsbase}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{jaxrsbase}.pom

#depmaps
%add_maven_depmap JPP-%{name}.pom
%add_maven_depmap JPP.%{name}-%{jsonprovider}.pom %{name}/%{jsonprovider}.jar -f %{jsonprovider}
%add_maven_depmap JPP.%{name}-%{smileprovider}.pom %{name}/%{smileprovider}.jar -f %{smileprovider}
%add_maven_depmap JPP.%{name}-%{jaxrsbase}.pom %{name}/%{jaxrsbase}.jar -f %{jaxrsbase}

#javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%post -n %{jsonprovider}
%update_maven_depmap

%post -n %{smileprovider}
%update_maven_depmap

%post -n %{jaxrsbase}
%update_maven_depmap

%postun
%update_maven_depmap

%postun -n %{jsonprovider}
%update_maven_depmap

%postun -n %{smileprovider}
%update_maven_depmap

%postun -n %{jaxrsbase}
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt README.md release-notes/*
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files -n %{jsonprovider}
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/%{jsonprovider}.jar
%{_javadir}/%{name}/%{jsonprovider}-%{namedversion}.jar
%{_javadir}/%{name}/%{jsonprovider}-javadoc.jar
%{_javadir}/%{name}/%{jsonprovider}-%{namedversion}-javadoc.jar
%{_javadir}/%{name}/%{jsonprovider}-sources.jar
%{_javadir}/%{name}/%{jsonprovider}-%{namedversion}-sources.jar
%{_mavenpomdir}/JPP.%{name}-%{jsonprovider}.pom
%{_mavendepmapfragdir}/%{name}-%{jsonprovider}

%files -n %{smileprovider}
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/%{smileprovider}.jar
%{_javadir}/%{name}/%{smileprovider}-%{namedversion}.jar
%{_javadir}/%{name}/%{smileprovider}-javadoc.jar
%{_javadir}/%{name}/%{smileprovider}-%{namedversion}-javadoc.jar
%{_javadir}/%{name}/%{smileprovider}-sources.jar
%{_javadir}/%{name}/%{smileprovider}-%{namedversion}-sources.jar
%{_mavenpomdir}/JPP.%{name}-%{smileprovider}.pom
%{_mavendepmapfragdir}/%{name}-%{smileprovider}

%files -n %{jaxrsbase}
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/%{jaxrsbase}.jar
%{_javadir}/%{name}/%{jaxrsbase}-%{namedversion}.jar
%{_javadir}/%{name}/%{jaxrsbase}-javadoc.jar
%{_javadir}/%{name}/%{jaxrsbase}-%{namedversion}-javadoc.jar
%{_javadir}/%{name}/%{jaxrsbase}-sources.jar
%{_javadir}/%{name}/%{jaxrsbase}-%{namedversion}-sources.jar
%{_mavenpomdir}/JPP.%{name}-%{jaxrsbase}.pom
%{_mavendepmapfragdir}/%{name}-%{jaxrsbase}

%files -n %{name}-javadoc
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%changelog
* Fri Apr 04 2014 Alex Wood <awood@redhat.com> 0:2.3.0-5
- In RHEL 7, jsr-311 has a hyphen.

* Thu Apr 03 2014 Alex Wood <awood@redhat.com> 0:2.3.0-4
- Use jsr311 instead of jsr311-api in RHEL 7.

* Thu Dec 19 2013 Alex Wood <awood@redhat.com> 0:2.3.0-3
- The JSON and Smile packages require the jaxrs base package at runtime.

* Thu Dec 19 2013 Alex Wood <awood@redhat.com> 0:2.3.0-2
- Correct Group to use standard value.

* Tue Dec 17 2013 Alex Wood <awood@redhat.com> 0:2.3.0-1
- Initial packaging.
